<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Logging &mdash; 4PointX Documentation 1.0 documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/sphinx_highlight.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            4PointX Documentation
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/introduction/index.html">Introduction</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/getting_started_with_4pointx_cloud/index.html">Getting Started with 4PointX Cloud</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/index.html">Deploy 4PointX Self-Managed</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/pre_requisites/index.html">Pre-requisites</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/pre_installation_guide/index.html">Pre Installation Guide</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/pre_installation_guide/k8s_installation_guide/index.html">K8S Installation Guide</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/pre_installation_guide/helm_installation_guide/index.html">Helm Installation Guide</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/deploy_4pointx_iaot_suite/index.html">Deploy 4PointX IAoT Suite</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/log_in_to_4pointx_iaot_suite/index.html">Log in to 4PointX IAoT Suite</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/index.html">Upgrade or Uninstall 4PointX</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/upgrade_4pointx_platform/index.html">Upgrade 4PointX Platform</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/uninstall_4pointx_platform/index.html">Uninstall 4PointX Platform</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/maintain_4px_cluster/index.html">Maintain 4PX Cluster</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/maintain_4px_cluster/k8s_dashboard_guide/index.html">K8S DASHBOARD Guide</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/maintain_4px_cluster/resize_4px_modules/index.html">Resize 4PX Modules</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/tls_security/index.html">TLS Security</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/tls_security/index.html#design">Design</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/tls_security/index.html#updating-ssl-certificates">Updating SSL Certificates</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/deploy_4pointx_self_managed/next_steps/index.html">Next Steps</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/apps/index.html">Apps</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/index.html">Energy Monitoring System (EMS)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/specific_energy/index.html">Specific Energy</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/idle_energy/index.html">Idle Energy</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/product_variation/index.html">Product Variation</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/index.html">Other Info - EMS</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html">Articles &amp; References - EMS</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#power-meters">Power Meters</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#oem-vendors">OEM Vendors</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#articles">Articles</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/apps/energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#things-you-should-consider-when-choosing-a-power-meter">3 Things You Should Consider When Choosing a Power Meter</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/index.html">Condition-based Maintenance (CBM)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/summary/index.html">Summary</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/asset_health_dashboard/index.html">Asset Health Dashboard</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html">Real-time Monitoring</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html#grouping-interval-logic-implemented-in-the-front-end">Grouping Interval logic implemented in the Front-End:</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html#code">Code:</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.html#id1">Code:</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/process_correlation/index.html">Process Correlation</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/fault_diagnostics/index.html">Fault Diagnostics</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/index.html">Other Info - CM</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html">Competitor Solutions - CM</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#teco-group">Teco Group</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#infinite-uptime">Infinite Uptime</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#web-app">Web App</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#sensor-manual">Sensor Manual</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#api-documentation">API Documentation</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#rs-485-modbus-specs">RS-485/ Modbus Specs</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#dashboard">Dashboard</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#gd-folder">GD Folder</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#datakrew">DataKrew</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#sample-cases">Sample Cases</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#case-1">Case 1</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#diagnostics">Diagnostics</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#detailed-report-attached">Detailed report attached</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#case-2">Case 2</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#id1">Diagnostics</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#id2">Detailed report attached</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#bk-vibro">BK Vibro</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#gantner-instruments">Gantner Instruments</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#vibro-meter">Vibro-meter</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#omnidots">Omnidots</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#rokade-rototechniks">Rokade Rototechniks</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/competitor_solutions_cm/index.html#cmtechnologies">cmtechnologies</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/articles_and_blogs_cm/index.html">Articles and Blogs - CM</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/condition_based_maintenance_cbm/other_info_cm/articles_and_blogs_cm/index.html#treatment-for-machine-vibration-problems">Treatment for Machine Vibration Problems</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/apps/predictive_maintenance_pdm/index.html">Predictive Maintenance (PdM)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/predictive_maintenance_pdm/asset_anomalies/index.html">Asset Anomalies</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/predictive_maintenance_pdm/process_anomalies/index.html">Process Anomalies</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/index.html">Other Info - PdM</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/competitor_solutions_anomaly/index.html">Competitor Solutions - Anomaly</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/competitor_solutions_anomaly/index.html#sparkcognition">SparkCognition</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/apps/predictive_maintenance_pdm/other_info_pdm/digital_twin_articles/index.html">Digital Twin articles</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/dashboards/index.html">Dashboards</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/alerting/index.html">Alerting</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/alerting/alerts/index.html">Alerts</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/alerting/watchers/index.html">Watchers</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/notebooks/index.html">Notebooks</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/data_management/index.html">Data Management</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/index.html">IoT Gateways</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html">IoT Gateways Introduction</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#data-onboarding">Data Onboarding</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#edge-iot-gateway">Edge IoT Gateway</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#modbus-rtu">Modbus RTU</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#opc-ua">OPC-UA</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#opc-server-python-producer-kafka-python-consumer-elasticsearch">OPC Server &gt; Python (Producer) &gt; Kafka &gt; Python (Consumer) &gt; Elasticsearch</a></li>
</ul>
</li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#modbus-tcp">Modbus TCP</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#file">File</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#steps-to-onboard-data-from-file">Steps to onboard data from File</a></li>
<li class="toctree-l7"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#installing-logstash">Installing Logstash</a><ul>
<li class="toctree-l8"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#centos">CentOS</a></li>
</ul>
</li>
<li class="toctree-l7"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#testing-transformed-data">Testing Transformed Data</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#third-party-apps">Third-Party Apps</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#infinite-uptime">Infinite Uptime</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#cimcon-digital">CimCon Digital</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#cloud">Cloud</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#aws-s3">AWS S3</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#google-cloud-storage">Google Cloud Storage</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/iot_gateways_introduction/index.html#azure-data-lake">Azure Data Lake</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/edge_iot_gateways/index.html">Edge IoT Gateways</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/edge_iot_gateways/index.html#initial-configuration-steps">Initial Configuration Steps</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/data_management/iot_gateways/edge_iot_gateways/index.html#testing-modbus-slaves">Testing Modbus Slaves</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/data_management/asset_metadata/index.html">Asset Metadata</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/data_management/asset_metadata/plants/index.html">Plants</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/data_management/asset_metadata/functions/index.html">Functions</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/data_management/asset_metadata/functions/function_monitors/index.html">Function Monitors</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/data_management/asset_metadata/assets/index.html">Assets</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/data_management/asset_metadata/assets/asset_monitors/index.html">Asset Monitors</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/administration/index.html">Administration</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/index.html">User Management</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/security_rbac/index.html">Security - RBAC</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/security_rbac/index.html#roles">Roles</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/security_rbac/index.html#plant-viewer">Plant Viewer</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/security_rbac/index.html#plant-analyst">Plant Analyst</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/security_rbac/index.html#plant-admin">Plant Admin</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/security_rbac/index.html#site-admin">Site Admin</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/support_users/index.html">Support Users</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/support_users/index.html#steps-to-create-support-users-ui">Steps to create support users (UI)</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/support_users/index.html#create-support-users-using-dev-tools">Create support users using Dev Tools</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/administration/user_management/support_users/index.html#repeat-step-no-5-for-support-admin-user">Repeat Step No. 5 for support-admin user.</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/administration/license_management/index.html">License Management</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/partners/index.html">Partners</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/partners/oem_partners/index.html">OEM Partners</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/partners/oem_partners/index.html#hardware-partners">Hardware Partners</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/partners/oem_partners/index.html#other-info">Other Info</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/partners/oem_partners/index.html#tecom">Tecom</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/partners/oem_partners/index.html#durham-instruments">Durham Instruments</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/partners/oem_partners/index.html#https-disensors-com-products-accelerometers-mems">https://disensors.com/products/accelerometers/mems/</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/partners/oem_partners/index.html#converters">Converters</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../4pointx_docs/test_page_for_sphinix_converter/index.html">Test page for sphinix converter</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../4pointx_docs/test_page_for_sphinix_converter/index.html#header-2">Header 2</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../4pointx_docs/test_page_for_sphinix_converter/index.html#header-3">Header 3</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../4pointx_docs/test_page_for_sphinix_converter/index.html#header-4">Header 4</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../4pointx_docs/test_page_for_sphinix_converter/index.html#header-5">Header 5</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../4pointx_docs/test_page_for_sphinix_converter/index.html#header-6">Header 6</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../../../4pointx_docs/test_page_for_sphinix_converter/how_to/index.html">How to</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">API Documentation</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../API/Asset_Metadata/index.html"><strong>Asset Metadata APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/assets.html"><strong>Assets</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/assets.html#create-asset"><strong>Create Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/assets.html#delete-asset"><strong>Delete Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/assets.html#update-asset"><strong>Update Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/assets.html#fetch-asset"><strong>Fetch Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/assets.html#fetch-list-of-assets"><strong>Fetch List of Assets</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/assets.html#get-count-of-assets"><strong>Get Count of Assets</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/functions.html"><strong>Functions</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/functions.html#create-a-function"><strong>Create a Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/functions.html#delete-a-function"><strong>Delete a Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/functions.html#update-function"><strong>Update Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/functions.html#fetch-function"><strong>Fetch Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/functions.html#fetch-list-of-functions"><strong>Fetch List of Functions</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/monitors.html"><strong>Monitors</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/monitors.html#create-a-monitor"><strong>Create a Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/monitors.html#delete-monitor"><strong>Delete Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/monitors.html#update-monitor"><strong>Update Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/monitors.html#fetch-monitors"><strong>Fetch Monitors</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/monitors.html#fetch-list-of-monitors"><strong>Fetch List of Monitors</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/monitors.html#get-count-of-monitors"><strong>Get Count of Monitors</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/plants.html"><strong>Plants</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/plants.html#create-a-plant"><strong>Create a Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/plants.html#delete-a-plant"><strong>Delete a Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/plants.html#update-plant"><strong>Update Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/plants.html#fetch-plant"><strong>Fetch Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/plants.html#fetch-list-of-plants"><strong>Fetch List of Plants</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines.html"><strong>Pipelines</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines.html#fetch-list-of-pipelines"><strong>Fetch List of Pipelines</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines.html#count-pipelines"><strong>Count Pipelines</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines.html#execute-pipeline-action"><strong>Execute Pipeline Action</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_edge.html"><strong>Pipelines (Edge Server)</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_edge.html#create-edge-server-pipeline"><strong>Create Edge Server Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_edge.html#delete-pipeline"><strong>Delete Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_edge.html#update-pipeline"><strong>Update Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_edge.html#fetch-pipeline"><strong>Fetch Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_edge.html#handshake"><strong>Handshake</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_edge.html#firmware"><strong>Firmware</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_IU.html"><strong>Pipelines (Infinite Uptime)</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_IU.html#create-iu-pipeline"><strong>Create IU Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_IU.html#delete-pipeline"><strong>Delete Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_IU.html#update-pipeline"><strong>Update Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/pipelines_IU.html#fetch-pipeline"><strong>Fetch Pipeline</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/sites.html"><strong>Sites</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/sites.html#create-a-new-site"><strong>Create a New Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/sites.html#delete-site"><strong>Delete Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/sites.html#update-site"><strong>Update Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/sites.html#fetch-site"><strong>Fetch Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/sites.html#fetch-list-of-sites"><strong>Fetch List of Sites</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/samples.html"><strong>Samples</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/samples.html#retrieve-sample-trend"><strong>Retrieve Sample Trend</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/samples.html#retrieve-sample-count"><strong>Retrieve Sample Count</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/tags.html"><strong>Tags</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/tags.html#retrieve-tags-list"><strong>Retrieve Tags List</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/tags.html#retrieve-tags-count"><strong>Retrieve Tags Count</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/tags.html#query-tags-trend"><strong>Query Tags Trend</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Asset_Metadata/others.html"><strong>Other APIs</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Asset_Metadata/others.html#server-time"><strong>Server Time</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../API/EMS/index.html"><strong>EMS APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../API/EMS/ems_asset.html">EMS Asset</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/EMS/ems_benchmarking.html"><strong>EMS Benchmarking</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_benchmarking.html#fetch-product-variation-table-for-plant"><strong>Fetch Product Variation Table for Plant</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/EMS/ems_function.html"><strong>EMS Function</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_function.html#fetch-energy-metrics-for-function"><strong>Fetch Energy Metrics for Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_function.html#fetch-energy-metrics-for-functions-in-plant"><strong>Fetch Energy Metrics for Functions in Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_function.html#fetch-energy-metric-trend-for-function"><strong>Fetch Energy Metric Trend for Function</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/EMS/ems_monitor.html"><strong>EMS Monitor</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_monitor.html#fetch-energy-metrics-for-monitor"><strong>Fetch Energy Metrics for Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_monitor.html#fetch-energy-metrics-monitors-in-plant-or-function"><strong>Fetch Energy Metrics Monitors in Plant or Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_monitor.html#fetch-energy-metric-trend-for-monitor"><strong>Fetch Energy Metric trend for Monitor</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/EMS/ems_plant.html"><strong>EMS Plant</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_plant.html#fetch-energy-metrics-for-plant"><strong>Fetch Energy Metrics for Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/EMS/ems_plant.html#fetch-energy-metric-trend-for-plant"><strong>Fetch Energy Metric trend for Plant</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../API/Notebooks/index.html"><strong>Notebooks APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Notebooks/notebooks.html"><strong>Notebooks</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#create-notebook"><strong>Create Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#delete-notebook"><strong>Delete Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#rename-notebook"><strong>Rename Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#fetch-notebook-details"><strong>Fetch Notebook Details</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#fetch-list-of-notebooks"><strong>Fetch List of Notebooks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#fetch-count-of-notebooks"><strong>Fetch Count of Notebooks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#run-notebook"><strong>Run Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#schedule-notebook"><strong>Schedule Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Notebooks/notebooks.html#unschedule-notebook"><strong>Unschedule Notebook</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../API/Alerting/index.html"><strong>Alerting APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Alerting/alerts.html"><strong>Alerts</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/alerts.html#fetch-alerts-count"><strong>Fetch Alerts Count</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/alerts.html#fetch-list-of-alerts"><strong>Fetch List of Alerts</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/alerts.html#fetch-alerts-trend"><strong>Fetch Alerts Trend</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Alerting/watchers.html"><strong>Watchers</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/watchers.html#create-watcher"><strong>Create Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/watchers.html#delete-watcher"><strong>Delete Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/watchers.html#update-watcher"><strong>Update Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/watchers.html#fetch-watcher"><strong>Fetch Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/watchers.html#fetch-list-of-watchers"><strong>Fetch List of Watchers</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Alerting/watchers.html#fetch-watcher-count"><strong>Fetch Watcher Count</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../API/User_Management/index.html"><strong>User Management APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../API/User_Management/user_management.html"><strong>Users</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/user_management.html#create-new-user"><strong>Create New User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/user_management.html#delete-user"><strong>Delete User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/user_management.html#updating-user"><strong>Updating User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/user_management.html#fetch-user"><strong>Fetch User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/user_management.html#fetch-list-of-users"><strong>Fetch List of Users</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/User_Management/password.html"><strong>Password</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/password.html#generate-otp"><strong>Generate OTP</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/password.html#validate-otp"><strong>Validate OTP</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/User_Management/password.html#update-user-password"><strong>Update User Password</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../API/Condition_Monitoring/index.html"><strong>CBM APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_assets.html"><strong>CM Assets</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_assets.html#cm-assets-list"><strong>CM Assets List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_events.html"><strong>CM Events</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_events.html#update-event"><strong>Update Event</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_events.html#fetch-event"><strong>Fetch Event</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_events.html#fetch-event-list"><strong>Fetch Event List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_faults.html"><strong>CM Faults</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_faults.html#cm-fault-s-status"><strong>CM Fault’s Status</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_monitors.html"><strong>CM Monitors</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_monitors.html#cm-monitor"><strong>CM Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_monitors.html#cm-monitors-list"><strong>CM Monitors List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_fft.html"><strong>CM FFT</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_fft.html#cm-fft-peaks"><strong>CM FFT Peaks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_fft.html#cm-asset-fault-summary"><strong>CM Asset Fault Summary</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_fft.html#cm-fft-spectrum"><strong>CM FFT Spectrum</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/Condition_Monitoring/cm_fft.html#cm-fft-spectrum-timestamps"><strong>CM FFT Spectrum Timestamps</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../API/License_Management/index.html"><strong>License Management APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../API/License_Management/license_management.html"><strong>Licenses</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../API/License_Management/license_management.html#generate-a-license"><strong>Generate a License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/License_Management/license_management.html#update-license"><strong>Update License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/License_Management/license_management.html#get-license"><strong>Get License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/License_Management/license_management.html#fetch-list-of-licenses"><strong>Fetch List of Licenses</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/License_Management/license_management.html#activate-licenses"><strong>Activate Licenses</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/License_Management/license_management.html#get-notification"><strong>Get Notification</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../API/License_Management/license_management.html#verify-app-access"><strong>Verify App Access</strong></a></li>
</ul>
</li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">4PointX Documentation</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Logging</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/developer_docs/devops/logging/index.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="logging">
<h1>Logging<a class="headerlink" href="#logging" title="Permalink to this heading">¶</a></h1>
<section id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this heading">¶</a></h2>
<ul><li><p>The logging framework is designed to get api, scripts logs to opensearch.</p></li><li><p>There are two parts here. </p><ul><li><p>one is logging for internal 4px services.</p></li><li><p>other is edge logging.</p></li></ul></li></ul><section id="internal-logging-of-4px-services">
<h3>1. Internal Logging of 4px services.<a class="headerlink" href="#internal-logging-of-4px-services" title="Permalink to this heading">¶</a></h3>
<ul><li><p>the APIs and python script generates file with .log , .error and .script extention.</p></li></ul><table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Extention</p></th>
<th class="head"><p>description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>.log</p></td>
<td><p>stores API call logs</p></td>
</tr>
<tr class="row-odd"><td><p>.error</p></td>
<td><p>contains error logs</p></td>
</tr>
<tr class="row-even"><td><p>.script</p></td>
<td><p>logs generated by python scripts</p></td>
</tr>
</tbody>
</table>
<ul><li><p>There is a unique persistent docker volume mounted to each 4px services.</p></li><li><p>the logs files are present in that directory.</p></li><li><p>To push this logs to opensearch, a python script is used.</p></li><li><p>This script is generalized for all 4px services.</p></li></ul><section id="python-script">
<h4>Python script:<a class="headerlink" href="#python-script" title="Permalink to this heading">¶</a></h4>
<ol start="1"><li><p>It is triggered by cron every 1min.</p></li><li><p>it will read every log file and delete the logs which are already read.</p></li><li><p>enrich/transform the log into suitable format.</p></li><li><p>push the logs to opensearch’s backend_logs index.</p></li></ol></section>
</section>
<section id="edge-logging">
<h3>2. Edge logging.<a class="headerlink" href="#edge-logging" title="Permalink to this heading">¶</a></h3>
<ul><li><p>the apis, script will generate their logs to some logs dir.</p></li><li><p>then kafka producer will send them to logs topic.</p></li><li><p>consumer will enrich/transform them and push it to opensearch.</p></li></ul></section>
<section id="sample-logs">
<h3>Sample logs<a class="headerlink" href="#sample-logs" title="Permalink to this heading">¶</a></h3>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span><span class="c1"># RAW</span>
<span class="m">172</span>.18.0.17<span class="w"> </span>-<span class="w"> </span>demo.analyst@4pointx.com<span class="w"> </span><span class="o">[</span><span class="m">09</span>/Jan/2023:10:23:22<span class="w"> </span>+0000<span class="o">]</span><span class="w"> </span><span class="s1">&#39;GET /_ems/plant/_trend/219019d7-bb0f-4a5c-89a7-753be0079dfe?from=2023-01-03T09%3A47%3A38.941Z&amp;to=2023-01-09T09%3A47%3A38.941Z&amp;metric=prod_vs_kwh_per_ton&amp;interval=day HTTP/1.0&#39;</span><span class="w"> </span><span class="m">200</span><span class="w"> </span><span class="m">869</span><span class="w"> </span><span class="s1">&#39;-&#39;</span><span class="w"> </span><span class="s1">&#39;-&#39;</span><span class="w"> </span><span class="k">in</span><span class="w"> </span>59ms

<span class="c1"># Transformed</span>
<span class="w">         </span><span class="o">{</span>
<span class="w">          </span><span class="s2">&quot;ip&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;172.22.0.13&quot;</span>,
<span class="w">          </span><span class="s2">&quot;user&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;admin&quot;</span>,
<span class="w">          </span><span class="s2">&quot;date&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;2023-01-12T08:26:21Z&quot;</span>,
<span class="w">          </span><span class="s2">&quot;method&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;GET&quot;</span>,
<span class="w">          </span><span class="s2">&quot;status_line&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;&#39;GET /_ems/plant/_trend/219019d7-bb0f-4a5c-89a7-753be0079dfe?from=2023-01-06T08%3A26%3A14.113Z&amp;to=2023-01-12T08%3A26%3A14.113Z&amp;metric=consumption_chart&amp;interval=day HTTP/1.0&#39;&quot;</span>,
<span class="w">          </span><span class="s2">&quot;status_code&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;415&quot;</span>,
<span class="w">          </span><span class="s2">&quot;response_length&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;40&quot;</span>,
<span class="w">          </span><span class="s2">&quot;referer&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;&#39;-&#39;&quot;</span>,
<span class="w">          </span><span class="s2">&quot;user_agent&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;&#39;-&#39;&quot;</span>,
<span class="w">          </span><span class="s2">&quot;request_time&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="m">60</span>,
<span class="w">          </span><span class="s2">&quot;request_unit&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;ms&quot;</span>,
<span class="w">          </span><span class="s2">&quot;type&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;INFO&quot;</span>,
<span class="w">          </span><span class="s2">&quot;file_name&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;plant.log&quot;</span>,
<span class="w">          </span><span class="s2">&quot;module&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;EMS&quot;</span>
<span class="w">          </span><span class="o">}</span>
</pre></div>
</div>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span><span class="c1"># RAW</span>
<span class="m">2023</span>-01-09<span class="w"> </span><span class="m">09</span>:55:30<span class="w"> </span>+0000<span class="o">]</span><span class="w"> </span><span class="o">[</span><span class="m">23</span><span class="o">]</span><span class="w"> </span><span class="o">[</span>ERROR<span class="o">]</span><span class="w"> </span><span class="s1">&#39;ems_plant_trend&#39;</span><span class="w"> </span>object<span class="w"> </span>has<span class="w"> </span>no<span class="w"> </span>attribute<span class="w"> </span><span class="s1">&#39;production_unit&#39;</span>
Traceback<span class="w"> </span><span class="o">(</span>most<span class="w"> </span>recent<span class="w"> </span>call<span class="w"> </span>last<span class="o">)</span>:
<span class="w">  </span>File<span class="w"> </span><span class="s2">&quot;/root/code/apis/ems_plant.py&quot;</span>,<span class="w"> </span>line<span class="w"> </span><span class="m">613</span>,<span class="w"> </span><span class="k">in</span><span class="w"> </span>get
<span class="w">    </span><span class="k">return</span><span class="w"> </span>metrics<span class="o">[</span>metric<span class="o">]()</span>
<span class="w">  </span>File<span class="w"> </span><span class="s2">&quot;/root/code/apis/ems_plant.py&quot;</span>,<span class="w"> </span>line<span class="w"> </span><span class="m">672</span>,<span class="w"> </span><span class="k">in</span><span class="w"> </span>_get_prod_vs_kwh_per_ton_metric
<span class="w">    </span><span class="k">if</span><span class="w"> </span>self.production_unit.lower<span class="o">()</span><span class="w"> </span><span class="o">==</span><span class="w"> </span><span class="s2">&quot;kg&quot;</span>:
AttributeError:<span class="w"> </span><span class="s1">&#39;ems_plant_trend&#39;</span><span class="w"> </span>object<span class="w"> </span>has<span class="w"> </span>no<span class="w"> </span>attribute<span class="w"> </span><span class="s1">&#39;production_unit&#39;</span>


<span class="c1"># Transformed</span>
<span class="w">        </span><span class="o">{</span>
<span class="w">          </span><span class="s2">&quot;event_timestamp&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;2023-01-12T08:26:16Z&quot;</span>,
<span class="w">          </span><span class="s2">&quot;type&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;ERROR&quot;</span>,
<span class="w">          </span><span class="s2">&quot;status_line&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;&#39;ems_plant_trend&#39; object has no attribute &#39;production_unit&#39;&quot;</span>,
<span class="w">          </span><span class="s2">&quot;response&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;&quot;&quot;Traceback (most recent call last):</span>
<span class="s2">                      File &quot;</span>/root/code/apis/ems_plant.py<span class="s2">&quot;, line 613, in get</span>
<span class="s2">                        return metrics[metric]()</span>
<span class="s2">                      File &quot;</span>/root/code/apis/ems_plant.py<span class="s2">&quot;, line 672, in _get_prod_vs_kwh_per_ton_metric</span>
<span class="s2">                        if self.production_unit.lower() == &quot;</span>kg<span class="s2">&quot;:</span>
<span class="s2">                      AttributeError: &#39;ems_plant_trend&#39; object has no attribute &#39;production_unit&#39;</span>
<span class="s2">                      &quot;&quot;&quot;</span>,
<span class="w">          </span><span class="s2">&quot;module&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;EMS&quot;</span>,
<span class="w">          </span><span class="s2">&quot;file_name&quot;</span><span class="w"> </span>:<span class="w"> </span><span class="s2">&quot;plant.error&quot;</span>
<span class="w">        </span><span class="o">}</span>
<span class="w">      </span><span class="o">}</span>
</pre></div>
</div>
<div class="toctree-wrapper compound">
</div>
</section>
</section>
</section>


           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, 4PointX.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>